/**************************************************************
	LCD VU Meter
	 for PIC16F88
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	version 1.71
	Tools:
	MPLAB v8.40
	Hitech PIC C pro9.70
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20090103 22:28	1.00	---		Begin the program
20090106 22:03	1.01			CG RAMp^[EEPROMɈړ
20090113 00:10	1.10			o[Ot炩ɓ悤ɂ
20090116 00:20	1.11			o[Ot̕ωASY̕ύX
20090122 02:10	1.12			ΐϊe[üꕔύX
20090215 06:38	1.20			o[OtXs[h̐ݒ肪\ɂȂ
20090216 04:00	1.21			LCD̏C
20090221 14:00	1.22			^C}[Ǘǉ
20090222 20:15	1.30			I[gobNCgIt@\ǉ
20090223 00:20	1.31			Fix minor issue 
20090401 07:20	1.32			Bug Fix 
20090503 15:20	1.33			HɃobNCgI[gX^[gȂoOC 
20090506 17:50	1.34			obNCg쒆̓P
20090506 23:10	1.35			eLCDɑΉ邽߂̃obNCgl
20090508 06:00	1.40			timer1gpobNCgItԂ𒷂\ɂ
20090811 22:00	1.41			ɂ mCYŒXLCDÂȂȂ̏C ׂ̑C
20090916 18:00	1.42			\ԈႢ̏C
20091013 20:00	1.50			dBv(ΐϊĒ)Volt(ΐILCD\)̐؂ւ@\ǉ
20091014 20:00	1.60			Tableǉ
20091015 08:30	1.61			ϐȂǂ̏C
20091018 16:12	1.62			change symbol name.( unsigned int linear2log -> unsigned char table10bitTo8bit )
								ݒ胂[hAobNCgÂ܂܂ɂȂĂ܂s̏C
20091022 07:00	1.63			j[[`SʕύXALR\̃j[ǉAo[Ot̕\dl̕ύX
20091022 21:30	1.64			LN^[[`2ޑIł悤ɂ j[[`̕ύX
20091023 05:40	1.65			LN^[`œK 4ނ̃LN^[𓋍
20091023 12:40	1.66			Hitech PIC C pro9.70Ή
20091117 03:15	1.67			Fix lcd.c
20100314 01:40	1.70			LCDobNCg̍ 60Hz->120Hz
20100331 21:53	1.71			timer0̎ԌvZC

---------------------------------------------------------------
Project folder(default)
	C:\picsrc\piccpro\lcd_bar
Source Files
	main.c (This file)
	lcd.c
Header Files
	lcd.h
---------------------------------------------------------------
Pin assignment
	1:RA2:O:LCD back light
	2:RA3:O:(not used)
	3:RA4:O:(not used)
	4:MCLR/RA5:I:(not used):PICKIT2-1(W/10kPU)
	5:VSS:GND
	6:RB0:I:(not used)
	7:RB1:I:SW1
	8:RB2:I:SW2
	9:RB3:O:PWM(LCD contrast)
	18:RA1:A:analog AN1(Left channel)
	17:RA0:A:analog AN0(Right channel)
	16:RA7:O:LCD E
	15:RA6:O:LCD RS
	14:VDD:Power 5 Volt
	13:RB7:O:LCD DB7/PICKIT2-5
	12:RB6:O:LCD DB6/PICKIT2-4
	11:RB5:O:LCD DB5
	10:RB4:O:LCD DB4
**************************************************************/
//CN[ht@CݒƁA__delay֐pgݒ
//U8MHzgp
#include <htc.h>
#include <stdlib.h>
#include "lcd.h"

//ϐ̋L錾
extern void delay_10ms(unsigned int temp);

//Frequency setting -> See lcd.h
//#define MHz 000000
//#define _XTAL_FREQ 8MHz

//I/O devices
#define PSW1 RB1	//switch(RED)
#define PSW2 RB2	//switch(Black)
#define Back_Light RA2	//LCD Back Light
#define off	0		//use LCD Back Light
#define on	255		//use LCD Back Light
#define Back_Light_PWM_Resolution 63	//Back Light LED max(0x3f)
#define Backlight_Sensitive 16	//obNCgĨx mCYŃobNCgItɂȂȂꍇ͒l傫***1.41


//RtBO QƐC:\Program Files\HI-TECH Software\PICC\9.70\include\pic16f87.h

__CONFIG(
	CCPRB3 & DEBUGDIS & LVPDIS & BOREN & MCLRDIS & PWRTEN & WDTDIS & INTIO
	);
__CONFIG(
	FCMDIS & IESODIS
	);

//linear to Log convert table(8bit) and paramater set
__EEPROM_DATA(0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A);//00-07
__EEPROM_DATA(0x0B,0x0C,0x0E,0x10,0x12,0x14,0x16,0x19);//08-0f
__EEPROM_DATA(0x1C,0x20,0x24,0x28,0x2D,0x33,0x39,0x40);//10-07
__EEPROM_DATA(0x48,0x50,0x5A,0x65,0x72,0x80,0x8F,0xA1);//18-1f
__EEPROM_DATA(0xB5,0xCB,0xE4,0xFF,0x1F,0x42,0x69,0x95);//20-27
__EEPROM_DATA(0xC7,0xFE,0x3C,0x82,0xD1,0x29,0x8B,0xFA);//28-2f

//Linear table(8bit)	***1.50
__EEPROM_DATA(0x10,0x3E,0x4B,0x57,0x64,0x70,0x7D,0x89);//30-38
__EEPROM_DATA(0x96,0xA2,0xAF,0xBB,0xC8,0xD4,0xE1,0xED);//39-3f
__EEPROM_DATA(0xFA,0x06,0x13,0x1F,0x2C,0x38,0x45,0x51);//40-48
__EEPROM_DATA(0x5E,0x6A,0x77,0x83,0x90,0x9C,0xA9,0xB5);//49-4f
__EEPROM_DATA(0xC2,0xCE,0xDB,0xE7,0xF4,0x00,0x0D,0x19);//50-58
__EEPROM_DATA(0x26,0x32,0x3F,0x4B,0x58,0x64,0x71,0x7D);//58-5f

//Linear table boost(8bit)	***1.60
__EEPROM_DATA(0x0A,0x0F,0x14,0x19,0x1E,0x23,0x28,0x2D);//60-67
__EEPROM_DATA(0x32,0x37,0x3C,0x41,0x46,0x4B,0x50,0x55);//68-6F
__EEPROM_DATA(0x5A,0x5F,0x64,0x69,0x6E,0x73,0x78,0x7D);//70-77
__EEPROM_DATA(0x82,0x87,0x8C,0x91,0x96,0x9B,0xA0,0xA5);//78-7F
__EEPROM_DATA(0xAA,0xAF,0xB4,0xB9,0xBE,0xC3,0xC8,0xCD);//80-87
__EEPROM_DATA(0xD2,0xD7,0xDC,0xE1,0xE6,0xEB,0xF0,0xF5);//87-8F

//CG RAM user character define 8 kinds	//[U[LN^`@
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x10);//90-97 (.   )

//CG RAM user character define 8 kinds	//[U[LN^` ^Cv1 m[} ***1.64
__EEPROM_DATA(0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00);//98-9f (|   )
__EEPROM_DATA(0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x00);//a0-a7 (||  )
__EEPROM_DATA(0x15,0x15,0x15,0x15,0x15,0x15,0x15,0x00);//a8-af (||| )
//CG RAM user character define 8 kinds	//[U[LN^` ^Cv2@x^@***1.65 
__EEPROM_DATA(0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x0);//b0-b7 (|  )
__EEPROM_DATA(0x1c,0x1c,0x1c,0x1c,0x1c,0x1c,0x1c,0x0);//b8-bf (|| )
__EEPROM_DATA(0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x0);//c0-c7 (|||)
//CG RAM user character define 8 kinds	//[U[LN^` ^Cv3  ***1.65
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x08,0x18,0x08,0x00);//c8-cf (| )
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x0c,0x1c,0x0c,0x00);//d0-d7 (|| )
__EEPROM_DATA(0x02,0x03,0x02,0x02,0x0e,0x1e,0x0c,0x00);//d8-df (||| )
//CG RAM user character define 8 kinds	//[U[LN^` ^Cv3 ^[Qbg ***1.65
__EEPROM_DATA(0x0,0xe,0x11,0x11,0x11,0xe,0x0,0x0);//e0-e7 (| )
__EEPROM_DATA(0x0,0xe,0x1f,0x1b,0x1f,0xe,0x0,0x0);//e8-ef (|| )
__EEPROM_DATA(0x0,0xe,0x1f,0x1f,0x1f,0xe,0x0,0x0);//f0-f7 (|||)

//Setting EEPROM area
__EEPROM_DATA(0x00,0xFF,0x08,0x0e,0x18,0x0a,0x06,0x3F);//f8-ff


//EEPROM setting address
#define EEPROM_ComplexRegisters			0xf8	//------Complex of registers---------	***1.64
												//bit 7		LR Display 0:no 1:yes
												//bit 6-5	Font Type  4 kinds	***1.65
												//bit 4		Reserve
												//bit 3-0	Table select (0,1,2)

#define EEPROM_Backlight				0xf9	//0xff:on else:off
#define EEPROM_LCD_Bar_Response			0xfa	//LCD bar response 0 to15 default is 8
#define EEPROM_Display_Marker			0xfb	//Default location is 14
#define EEPROM_Contrast_Adjust			0xfc	//Default value is 24(0x18)	***1.35
#define EEPROM_Auto_LCD_Light_Value		0xfd	//Default value is 10(0x0a) ***1.35
#define EEPROM_Backlight_Min			0xfe	//Default value is 0x0
#define EEPROM_Backlight_Max			0xff	//Default value is 0x3F

#define CGRAM_Marker_Address			0x90	//CG RAM user character Marker address ***1.47
#define Table_Data_Quantity 			48		//Number of data on table 0x2f ***1.66

//Other data
#define LCD_Line1 						0x00	//LCD 1i
#define LCD_Line2 						0x40	//LCD 2i
#define LCD_Contrast_Default			0x18	//LCDRgXgݒ
#define LCD_Contrast_Offset				96		//LCDRgXgItZbg ***1.35
#define Opening_Message 				"LCD VU ver 1.71"

//O[oݒ
unsigned int timer0_temp_conuter		=0;	//for use timer0 internal counter ***1.71
unsigned char timer_50msec;					//50msec down counter
unsigned char timer1_temp_conuter		=0;	//for use timer1 internal counter
unsigned char timer_1sec;					//1sec down counter ***1.40

//LCD back light control
unsigned char backlight_pwm_cnt			=63;
unsigned char backlight_delta_speed		=10;
unsigned char backlight_power			=32;

//EEPROM address scorp table on RAM
unsigned char table_address_scope[4];	//need 4 sectors 


//4 levels adjutable mark
const unsigned char bar_mark[]={
	' ',0x01,0x02,0x03
};

//4 levels adjustable mark with guide marking
const unsigned char guide_mark[]={
	0x00,0x04,0x05,0x06
};

//Table start address ***1.60
const unsigned char table_start_address[]={
	0x00,0x30,0x60
};

//Character start address ***1.65
const unsigned char Character_start_address[]={
	0x98,0xb0,0xc8,0xe0
};




//interrupt handle
void interrupt handler( void ){	
	//timer 0 
	if (TMR0IF == 1){
		if ((++timer0_temp_conuter >390)&&(timer_50msec>0)){	//0.05b ***1.71
			timer0_temp_conuter=0;
			--timer_50msec;
		}

		//LCD Back light control (about 120Hz)
		if ( backlight_pwm_cnt-- <= backlight_power) Back_Light = 1;
			else Back_Light = 0;
		if (backlight_pwm_cnt ==0 ) backlight_pwm_cnt=Back_Light_PWM_Resolution;

		TMR0IF =0;
	}
	if (TMR1IF == 1){	//0.262155ms ***1.40 
		if ((++timer1_temp_conuter >3)&&(timer_1sec >0)){	//1b***1.40
			timer1_temp_conuter=0;
			--timer_1sec;
		}
		TMR1IF =0;
	}

	return;
}

void adinit(void){
	ADON	=	1;	//AD convert power on
	ADFM	=	1;	//justify to the right
	VCFG1	=	0;	//Vref+ =Vdd
	VCFG0	=	0;	//Vref- =Vss
	ADCS1 	=	1;
	ADCS0 	=	1;	//use internal RC OSC
}

unsigned int adconv(char adselect){	//PIC16F88p
	unsigned int temp;
	ADCON0 = (ADCON0 & 0b11000111) |(( adselect <<3) & 0b00111000);//AD`lZbg 
	__delay_us(20);//more than 20us
	ADIF =0;
	GODONE=1;	//convert start!
	while(GODONE);//progress AD convert
	temp =ADRESH;
	temp =( temp<<8 )| ADRESL;
	return temp;
}


void lcd_valueout8(unsigned char temp){	//[TvXΉ
	if (temp<100) {
		lcd_putch(' ');
	}else	lcd_putch(((temp / 100)%10)+0x30);//100
	if (temp<10) {
		lcd_putch(' ');
	}else	lcd_putch(((temp /  10)%10)+0x30);//10
	lcd_putch(((temp      )%10)+0x30);//1
	return;
}

/*
//fobOł̂ݎgp
void lcd_valueout(unsigned int temp){	//[TvXΉ
	if (temp<1000) {
		lcd_putch(' ');
	}else	lcd_putch(((temp /1000)%10)+0x30);//1000
	if (temp<100) {
		lcd_putch(' ');
	}else	lcd_putch(((temp / 100)%10)+0x30);//100
	if (temp<10) {
		lcd_putch(' ');
	}else	lcd_putch(((temp /  10)%10)+0x30);//10
	lcd_putch(((temp      )%10)+0x30);//1
	return;
}

//fobOł̂ݎgp
void lcd_valueout2d1(unsigned int temp){	//[TvXΉ _\[`(󂯎l1/10ŕ\)
	if (temp<100) {
		lcd_putch(' ');
	}else	lcd_putch(((temp /100)%10)+0x30);//100
	lcd_putch(((temp /10)%10)+0x30);//10
	lcd_putch('.');
	lcd_putch(((temp )%10)+0x30);//1
	return;
}

*/

//ŏLCDʒulcd_goto()Ŏw肷(i0,i0x40)
//bar = 0 to 48 , guide =0 to 16 , cut_chr=0 to 16 ***1.63
//bar̓o[̐ guidemarker̈ʒu cut_chr͕\ȂLN^[ ***1.63
void lcd_bar48(unsigned char bar,unsigned char guide,unsigned cut_chr){
	unsigned char i,j,temp,cut_bar;
	cut_bar = cut_chr * 3;									//JbgLN^[̃o[vZ ***1.63
	if (bar >48) bar =48;									// Ber Limiter ***1.50
	if (bar > cut_bar) bar -= cut_bar;	else bar=0;			//Jbg̈o[vZ***1.63
	i = bar	/3;												//48iK16iKɂ
	guide -= cut_chr;										//KCh}[JʒuvZ***1.63
	temp =i;												//16iK̐ޔ
	j=0;
	while(i--){
		if (j++ == guide) lcd_putch( guide_mark[3]);		//KCh}[N΁AKCh}[Nt̃L\
		 else lcd_putch( bar_mark[3] );						//ro[\( |||)
	}	
	if (bar<(48 - cut_bar)){								//c̃LN^[\̊mF
		if ( temp == guide) lcd_putch( guide_mark[bar%3]);	//KCh}[N΁AKCh}[Nt̃L\
		 else lcd_putch( bar_mark[bar%3] );					//ׂo[vZĕ\
		i=16-temp-cut_chr;									//㔼LN^vZ
		while(--i){
			if ( ++j == guide) lcd_putch( guide_mark[0]);	//KCh}[N΁AKCh}[N\
			 else lcd_putch(' ');							//󔒂Ŗ߂
		}	
	}
	return;
}

void EEPROM_scorp_init(void){	//ϊe[uEEPROM̃AhX͈͒
	unsigned char i,temp,temp2,arrow=0,buff=0xff;			//***1.50
	temp2 = (EEPROM_READ(EEPROM_ComplexRegisters))&0x0f;	// ***1.50 Get table offset address ***1.64
	temp2 = table_start_address[temp2];						// ***1.60
	for ( i= 0; i< Table_Data_Quantity ;i++ ){				// ***1.66 
		temp = EEPROM_READ( i + temp2);						// ***1.50
		if (buff > temp ){		//Af[^ɕω΁A̕𒊏o͈͂肷
			table_address_scope[arrow++]=i;
			if (arrow >4) return;
		}
		buff=temp;
	}
	for ( i= arrow ;i <5 ;i++){	// gpZN^[0xffŖ߂ ***1.50
		table_address_scope[i]=0xff;
	}			
	return;
}

unsigned char table10bitTo8bit(unsigned int value){	//e[uϊ	***1.62
	unsigned char temp,temp2,i,start_address,end_address;
	if ( value < (unsigned int)EEPROM_READ(table_address_scope[0])) return (0);//\
	temp = (unsigned char)(value/256);			//sectoro
	switch (temp){								//sectore[uAhXo
		case 0:// -0x00xx
		 start_address 	= table_address_scope[0];
		 end_address 	= table_address_scope[1]-1;
		 break;
		case 1:// 0x01xx-
		 start_address 	= table_address_scope[1];
		 end_address 	= table_address_scope[2]-1;
		 break;
		case 2:// 0x02xx-
		 start_address 	= table_address_scope[2];
		 end_address 	= table_address_scope[3]-1;
		 break;
		case 3:// 0x03xx-
		default:
		 start_address 	= table_address_scope[3];
		 end_address 	= Table_Data_Quantity -1;	//***1.66
		 break;
	}
	temp = (unsigned char)(value&0x00ff);		//8rbgo
	temp2 = (EEPROM_READ(EEPROM_ComplexRegisters))&0x0f;	// ***1.50 Get table offset address ***1.64
	temp2 = table_start_address[temp2];					// ***1.60
	for (i=start_address ; i<=end_address;i++){	//e[uϊ
		if (temp <= EEPROM_READ(i + temp2)) {	//***1.50
			++i;
			break;
		}	
	}
//	if (value >EEPROM_READ(48)) i =48;//Full scale
	return(i);///o[Ot̑傫i̒lo[̃|WVɂȂ
}

// EEPROMep[^XVmF
void chekc_EEPROM_Value(unsigned char ADR,unsigned char DATA){
	unsigned char temp=40;	//timer set
	if (DATA != EEPROM_READ(ADR)){
		EEPROM_WRITE(ADR,DATA);
//		lcd_goto(LCD_Line2);	//***1.70 remark
//		lcd_puts("Update new value");//ύXbZ[W
		while(temp--) __delay_ms(10);
	}
	delay_10ms(10);
//	temp = 10;
//	while(temp--) __delay_ms(10);
	return;
}

void delay_10ms(unsigned int temp){	//10ms multiple x times
	while(temp--){
		__delay_ms(10);
	}	
}

//[U[LN^[tHgLCDCG RAM֓] ***1.64 ***1.65
void lcd_CG_init(void){
	unsigned char i,j,temp,temp2,temp3;
	lcd_write(0x40);				//CG RAM[h 0ԒnZbg
	//ʃLN^[̃Zbg Pޕ ***1.64

	temp = CGRAM_Marker_Address;								//CG RAM start address set
	for (j=0;j<8;j++){
		lcd_cgwrite(EEPROM_READ(temp++));							//CG RAMLN^Zbg(8ij
	}

	temp2 = (EEPROM_READ(EEPROM_ComplexRegisters))&0x60;	// ***1.50 Get table offset address ***1.65
	temp2 >>=5;	// shift
	temp = Character_start_address[temp2] ;	// LN^[Zbg***1.65 

	temp3=temp;	//Keep original address on RAM
	for (i=0;i<3;i++){										//3ނ̃Zbg ***1.65
		for (j=0;j<8;j++){
			lcd_cgwrite(EEPROM_READ(temp++));				//CG RAMLN^Zbg(8ij
		}
	}
	temp = temp3;	//Reset CG RAM address ***1.65
	//Genete CG character within Marker
	for (i=0;i<3;i++){										//3ނ̃Zbg ***1.65
		for (j=0;j<8;j++){
			temp2  =EEPROM_READ(temp++);
			temp2 |=EEPROM_READ(CGRAM_Marker_Address+j);	//combining
			lcd_cgwrite(temp2);								//CG RAMLN^Zbg(8ij
		}
	}

	lcd_write(0x80);										//DD RAM [hZbg
	lcd_goto(0x00);											//LCD̕\ʒuz[փZbg
	return;
}

//Menu display common j[̋ʂ̕Tu[` ***1.63
unsigned char Menu_Display_Common( const char *s,unsigned char EPROM){
	lcd_clear();
	lcd_goto(LCD_Line1);
	while(*s)
		lcd_putch(*s++);
	delay_10ms(10);	
	return(EEPROM_READ(EPROM));
}	

//------------------main------------------------------------------------------------------
void main(void){
//gpϐ̐錾
	unsigned char temp,temp2,temp3,i,j,bar,Backlight_manual=0,key_release=0;	//***1.63
	unsigned int temp16;//general purpose
	unsigned char Backlight_updown_counter ;
	unsigned char Counter_event_status=1;	//***1.65
	unsigned char Backlight_Max,Backlight_Min;
//ADRo[^p ***1.50
	unsigned int adc_data[2];					//ADRo[^l
	unsigned int adc_average_dilution[2]={0,0};	//ADRo[^l̕ω


//NbNݒ
	OSCCON = 0b01110000;	//8MHz,__configłFOSCݒ
		
//e|[g̏
//		  	  76543210
	PORTA = 0b00000000;		//|[gA
	PORTB = 0b00000000;		//|[gB
	TRISA = 0b00111011; 	//|[gA̕ݒ
	TRISB = 0b00000111; 	//|[gB̕ݒ

	ANSEL = 0b00000011;		//AiO|[g2`lgp
	CMCON = 0x07;			//|[gAfW^I/OƂĎgp
	RBPU  = 0;				//|[gBvAbvݒ

//Timer0ݒ 1/((8MHz/4 )/2)=0.5usec x256= 128usec ***1.70
	//***1.70 vXP[[gpȂŃ_CNgɂ
	PS2 = 0;
	PS1 = 0;
	PS0 = 0;
	//T0 Clock Source is internal clock
	T0CS = 0;
	PSA = 1;	//***1.70 vXP[[gpȂŃ_CNgɂ
    TMR0   = 0x00 ;

//Timer1 free counter ***1.40
	TMR1H =0;
	TMR1L =0;
	T1CON = 0b00110001;//Prescale 1/8 ,sync ,internal ,enable 

//Timer2 PWM mode LCDRgXgp PWM (7.812KHz on RB3 @8MHz)
	CCP1CON = 0b00001100;// use PWM mode
	PR2 = 0xff; // resolution is 10bit mode
	CCPR1L = LCD_Contrast_Default; // duty control (value 0x20 as 50%)
	T2CON = 0b00000100;	// POSTSCALE 1:1 ,TMR2 ON , PRESCALE 1:1

//EEPROM͈͒Ɗm
	EEPROM_scorp_init();

//adRo[^
	adinit();
	
//ԑ҂id肷܂0.5b҂)
	delay_10ms(20);		//0.01bx20 = 0.2b^C}[ 

//LCD
	lcd_init();		//LCD
	lcd_clear();	//LCD\NAɂ
	lcd_write(0x0c);			//J[\\Ȃ
	lcd_CG_init();//[U[LN^[tHgLCDCG RAM֓]


//{^2Ȃd𓊓ƁARgXĝݏԂɖ߂悤ɂ***1.34
//[ߖ񂩂ARgAEg ***1.65
/*
	if (!PSW2 && !PSW1){
//		EEPROM_WRITE(EEPROM_LCD_Bar_Response,8);
//		EEPROM_WRITE(EEPROM_Display_Marker,14);
		EEPROM_WRITE(EEPROM_Contrast_Adjust,0x18);
//		EEPROM_WRITE(EEPROM_Backlight,on);
//		EEPROM_WRITE(EEPROM_Auto_LCD_Light_Value,0x0a);
//		lcd_clear();
//		lcd_goto(LCD_Line1);
//		lcd_puts("Default setting.");
//		while(!PSW1);		
	}

*/

//LCDZxݒ

	CCPR1L = LCD_Contrast_Offset - EEPROM_READ(EEPROM_Contrast_Adjust) * 2 ;

//荞݋

	TMR0IE 	= 1;	//Timer0 interrupt on
	TMR1IE 	= 1;	//Timer1 interrupt on ***1.35
	PEIE 	= 1;	//ӊ荞݋
	GIE  	= 1;	//荞݋


//I[vjOauthor\ ***1.64
/*
	lcd_goto(LCD_Line1);
	lcd_puts(Opening_Message);
	lcd_goto(LCD_Line2);
	lcd_puts("2009 AirVariable");
	temp =48;
	while(--temp){
		backlight_power =48-temp ;
		delay_10ms(5);
	}
*/

//LCDZxݒ

 	// duty control (value 0x20 as 50%) ***1.35
	CCPR1L = LCD_Contrast_Offset - EEPROM_READ(EEPROM_Contrast_Adjust) * 2 ;

//d㎞̃obNCgݒ

	if (EEPROM_READ(EEPROM_Backlight) == on ){
		backlight_power = EEPROM_READ(EEPROM_Backlight_Max);
	}else{
		backlight_power = EEPROM_READ(EEPROM_Backlight_Min);
	}	
		
//timer clear
	timer0_temp_conuter=0;
	timer_50msec =30;


//obNCgl擾
	Backlight_Max = EEPROM_READ(EEPROM_Backlight_Max);//***1.41
	Backlight_Min = EEPROM_READ(EEPROM_Backlight_Min);//***1.41


//[vJn
	while(1){		


//ADl擾
		for (i=0;i<2;i++){	//2`lADl擾
			adc_data[i]=  adconv(i);
		}

//ADl̕ω
		temp = 	EEPROM_READ(EEPROM_LCD_Bar_Response);//X|Xl̎擾
		for (i=0;i<2;i++){
			adc_average_dilution[i] = (adc_data[i]*2 + adc_average_dilution[i] * temp)/(temp+1);//ω
			adc_data[i] = adc_average_dilution[i] /2;					// ωꂽlo
			if ( (adc_average_dilution[i] % 2 ) > 0) adc_data[i]++;		// lۂߏ
		}	

// o[̕`(2i)	***1.63
		if (Counter_event_status <7) {	// \LȎ***1.35
			for (i=0;i<2;i++){
				temp=table10bitTo8bit(adc_data[i]);		//e[uϊ ***1.62
				lcd_goto(0x40*i);				//LCD̕\ʒuvZ(SC1602BS̏ꍇ)
				temp2 = EEPROM_READ(EEPROM_ComplexRegisters);	// LR display̐ݒ蒲 ***1.64
				if ((temp2 & 0x80) == 0x80){					//L/R\ ***1.64
					temp2 =1;
					if( i==0) lcd_putch('L');
						else lcd_putch('R');
				}
				else temp2=0;
				lcd_bar48(temp,EEPROM_READ(EEPROM_Display_Marker),temp2);	//***1.64
			}
		}
			
		//For debug only
//		lcd_goto(0x45);
//		lcd_valueout(Counter_event_status);
//		lcd_goto(0x40+13);
//		lcd_valueout8(timer_50msec);
//		lcd_valueout8(timer_1sec);	//***1.40
		//lcd_valueout8(backlight_power);

//obNCgIIt
		if (( !PSW1 ) && (key_release==0)) {		//{^`FbN
			key_release=1;
			if (EEPROM_READ(EEPROM_Backlight) == off ){
				backlight_power = Backlight_Max;
				Counter_event_status=8;
				EEPROM_WRITE(EEPROM_Backlight,on);
			}else{
				backlight_power = Backlight_Min;
				Counter_event_status=7;
				EEPROM_WRITE(EEPROM_Backlight,off);
			}
		}	
		if (  PSW1 ) {		//{^ꂽ̃`FbN
			key_release=0;
		}		

//Auto LCD Backlight control //debug 20090222
		temp = EEPROM_READ(EEPROM_Auto_LCD_Light_Value);	//ޯCg䂩𒲂ׂ
		if (temp != 0 ){
			temp16 = (adc_average_dilution[0]+adc_average_dilution[1])/2;	//Ă邩`FbN
			switch (Counter_event_status){
			 case 0: //if (temp16 > Backlight_Sensitive)
				if (temp16 > Backlight_Sensitive) Counter_event_status=1;
					else Counter_event_status=4;
			 	break;

			//LED sunrise
			 case 1:
			 	Counter_event_status=2;
			 	timer_50msec = Backlight_Max-Backlight_Min;
			 	break;

			 case 2:	// Now rising up
			 	backlight_power = Backlight_Max- timer_50msec;
				if (backlight_power >= Backlight_Max) Counter_event_status=3;
			 	break;

			 case 3:	// backlight is MAX
				if (temp16 <= Backlight_Sensitive) Counter_event_status=4;
			 	break;
			// LED sunset
			 case 4:
			 	timer_1sec = temp;//set Auto_LCD_Light_Value 1b^C}[ ***1.40
			 	Counter_event_status=5;
			 	//lcd_clear();	//LCD for debug ***1.35
			 	break;

			 case 5:	//Sound off timer
				//lcd_goto(0x40+13);			//for debug ***1.40
				//lcd_valueout8(timer_1sec);	//for debug ***1.40
				if (temp16 > Backlight_Sensitive) Counter_event_status=3;
			 	if (timer_1sec ==0){	//***1.40
				 	timer_50msec = Backlight_Max-Backlight_Min;
				 	Counter_event_status=6;
				 }	
			 	break;

			 case 6:	// backlight falling down
			 	//lcd_clear();	//LCD for debug ***1.35
			 	backlight_power = timer_50msec;
				if (temp16 > Backlight_Sensitive) {	//ޯCgfall downɉĂrise up
					Counter_event_status=2;	//***1.34
				 	timer_50msec = Backlight_Max-Backlight_Min - timer_50msec;//c莞Ԃ𗧂オ莞ԂɊ蓖 ***1.34
				} 	
					
				if (backlight_power <= Backlight_Min) Counter_event_status=7;
			 	break;

			 case 7:	//Idling state
			 	lcd_clear();	//LCD***1.35
				if (temp16 > Backlight_Sensitive) Counter_event_status=1;//***1.33
			 	break;
			 	
			 case 8://reset
			 	backlight_power == Backlight_Max;
			 	Counter_event_status=4;
			 	break;
		 
 			 default:	//illigal reset state
			 	Counter_event_status=7;
		 	 	break;
			}
		}

	
//RtBO[V

		if ( !PSW2 ){ // Configuration
			delay_10ms(10);
			backlight_power=EEPROM_READ(EEPROM_Backlight_Max);//***1.33 **1.63
			lcd_goto(LCD_Line1);
			lcd_puts(Opening_Message);	//version \(ςȂ)	***1.65
			delay_10ms(50);	//***1.70	
			while(!PSW2);
			
		//Guide Marker
			temp= Menu_Display_Common("Guide Marker",EEPROM_Display_Marker);
			while(PSW2){
				lcd_goto(LCD_Line2);
				lcd_bar48(0,temp,0);	//	**1.63
				lcd_goto(LCD_Line1+13);
				lcd_valueout8(temp);
				if ( !PSW1 ) {
					temp ++;
					if (temp >16) temp =0;
					delay_10ms(20);
					//while(!PSW1);
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_Display_Marker,temp);

		//Contrast ADJ.
			temp= Menu_Display_Common("Contrast ADJ.",EEPROM_Contrast_Adjust);	// ***1.63
			while(PSW2){
				lcd_goto(LCD_Line2);
				lcd_bar48(temp,16,0);
				if ( !PSW1 ) {
					temp ++;
					if (temp >48) temp = 0;
					CCPR1L= LCD_Contrast_Offset - temp *2 ;
					delay_10ms(10);	//***1.35
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_Contrast_Adjust,temp);	//***1.34

		//LCD Auto Backlight ***1.63
			temp= Menu_Display_Common("Auto Backlight",EEPROM_Auto_LCD_Light_Value);
			lcd_goto(LCD_Line2);
			lcd_puts("0-254");
			while(PSW2){
				lcd_goto(LCD_Line2+10);
				lcd_valueout8(temp);
				lcd_puts("sec");
				lcd_goto(LCD_Line2);
				if ( !PSW1 ) {
					temp+=2;
					delay_10ms(5);
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_Auto_LCD_Light_Value,temp);

		//LCD MIN Backlight value ***1.63
			temp= Menu_Display_Common("Backlight MIN",EEPROM_Backlight_Min);
			lcd_goto(LCD_Line2);
			lcd_puts("0-20");
			Backlight_Min=temp;//***1.41
			while(PSW2){
				lcd_goto(LCD_Line2+13);
				lcd_valueout8(Backlight_Min);//***1.41
				backlight_power=Backlight_Min;//***1.41
				lcd_goto(LCD_Line2);
				if ( !PSW1 ) {
					Backlight_Min ++;//***1.41
					if (Backlight_Min >20) Backlight_Min =0;//***1.41
					delay_10ms(10);
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_Backlight_Min,Backlight_Min);

		//LCD MAX Backlight value ***1.63
			temp= Menu_Display_Common("Backlight MAX",EEPROM_Backlight_Max);
			lcd_goto(LCD_Line2);
			lcd_puts("21-63");
			backlight_power=Backlight_Max=temp;//***1.41 ***1.62 ***1.63
			while(PSW2){
				lcd_goto(LCD_Line2+13);
				lcd_valueout8(Backlight_Max);//***1.41
				backlight_power=Backlight_Max;//***1.41
				lcd_goto(LCD_Line2);
				if ( !PSW1 ) {
					Backlight_Max ++;//***1.41
					if (Backlight_Max >63) Backlight_Max =21;//***1.41
					delay_10ms(10);
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_Backlight_Max,Backlight_Max);//***1.41


		//Complex Registers Group--------------------------------------------------
			temp3 = (EEPROM_READ(EEPROM_ComplexRegisters));//lޔ ***1.64

		//Complex Registers Group--Table change	***1.50 ***1.63 ***1.64
			temp= Menu_Display_Common("Display measure",EEPROM_ComplexRegisters);	//***1.63 ***1.64
			temp = temp & 0x0f;	//lo***1.64
			while(PSW2){
				lcd_goto(LCD_Line2+10);
				if (temp ==0) 			lcd_puts("   dBv");
					else if (temp ==1) 	lcd_puts("  Volt");
					else 				lcd_puts("BoostV");

				//lcd_goto(LCD_Line2+10);
				//lcd_valueout8(temp);
				if ( !PSW1 ) {
					temp++;		//***1.60
					temp%=3 ;	//***1.60
					delay_10ms(20);
				}
			}
			while(!PSW2);
			temp3 = (temp3 & 0xf0)|temp	;					//l***1.64

		//Complex Registers Group--LR display on/off 	***1.63
			temp= Menu_Display_Common("LR Display",EEPROM_ComplexRegisters);	//***1.63 ***1.64
			temp = temp & 0x80;	//lo***1.64
			while(PSW2){
				lcd_goto(LCD_Line2+13);
				if (temp==0x00)	lcd_puts(" No");	//***1.64
					else lcd_puts("Yes");
					
				//lcd_goto(LCD_Line2+10);
				//lcd_valueout8(temp);
				if ( !PSW1 ) {
					temp^=0x80 ;	//l] ***1.64
					delay_10ms(20);
				}
			}
			while(!PSW2);
			temp3 = (temp3 & 0x7f)|temp	;					//l***1.64

		//Complex Registers Group--Character Type setting 	***1.65
			temp= Menu_Display_Common("Character set",EEPROM_ComplexRegisters);	//***1.63 ***1.64
			temp = temp & 0x60;	//lo***1.65
			temp >>=5;	// shift
			while(PSW2){
			lcd_goto(LCD_Line2+9);
			lcd_puts("Type");
				lcd_valueout8(temp+1);
				//lcd_goto(LCD_Line2+10);
				//lcd_valueout8(temp);
				if ( !PSW1 ) {
					temp++;
					temp %=4 ;	//l(0 to 3) ***1.64
					delay_10ms(20);
				}
			}
			while(!PSW2);
			temp <<=5 ;//shift
			temp &=0x60;//mask
			temp3 = (temp3 & 0x9f)|temp	;					//l***1.64

		//Complex Registers Group--writing result of EEPROM_ComplexRegisters
			chekc_EEPROM_Value(EEPROM_ComplexRegisters,temp3);
			lcd_CG_init();					//LN^[Ē` ***1.64
			EEPROM_scorp_init();			//e[uXR[vĒ` ***1.64

		//LCD Bar response
			temp = Menu_Display_Common("Bar Response",EEPROM_LCD_Bar_Response);	//***1.63
			while(PSW2){
//				lcd_goto(LCD_Line1+13);
				lcd_goto(LCD_Line2+13);//***1.50
				lcd_valueout8(temp);
/*
			//[Ȃ̂ŃRgAEg***1.50
				//E`l̃j^[Ȃݒł悤ɂĂ
				adc_data[1]=  adconv(1);
				//ADl̕ωiÊ݁j
				adc_average_dilution[1] = 
					(adc_data[1]*2 + adc_average_dilution[1] * temp)/(temp+1);
				adc_data[1] = adc_average_dilution[1] /2;
				if ( (adc_average_dilution[1] % 2 ) > 0) adc_data[1]++;

				lcd_goto(LCD_Line2);
				adc_data[1]=table10bitTo8bit(adc_data[1]);
				lcd_bar48(adc_data[1],EEPROM_READ(EEPROM_Display_Marker),0);
*/
				if ( !PSW1 ) {
					temp ++;
					if (temp >15) temp =0;
					delay_10ms(20);
				}
			}
			while(!PSW2);
			chekc_EEPROM_Value(EEPROM_LCD_Bar_Response,temp);

			//Final display
			Counter_event_status=1;
			lcd_clear();
			lcd_goto(LCD_Line1);
			lcd_puts("End of Config.");
			
			delay_10ms(50);

//			lcd_clear();
		}	


	}
}		
